
 '=============================================================================
 'MAXIMITE BASIC v.3.1A 8.4.2012
 'AUTHOR: JA
 'DEMO PROGRAM use Shift register 74HC595 LCD Display control
 ' 
 '====== DEFINICE POUZITI PINU ================================================
 LWRITE=14
 SCLK=15
 SDATA=16
 SPIREAD=10 'Even we read nothing we have to define RX
 '====== SET UP pin LOG level===================================
 Pin(LWRITE)=0
 Pin(SCLK)=0
 Pin(SDATA)=0
 Pin(SPIREAD)=1
 '======= SET UP PINS 2-INPUT,8-OUTPUT ==============================
 SetPin LWRITE,8
 SetPin SCLK,8
 SetPin SDATA,8
 SetPin SPIREAD,2
 Dim ZNAK(32)
 Dim ZANKN(32)
 Dim CAS(32)
 Dim RTCBUFF(64)
 LCD_MODE$ = "SPI4" 'LDC4,LCD8,SPI4,SPI8,I2C4

'==============  RTC =====================================
  ERR=0
  SYNC=0  'SYNCHRONIZATION RTC AND TIME$ 
 '============= Definice INTERRUPTU ===========================================
 SetTick 1000,DEJCAS  ' INTERRUPT EVERY 1s
 '-----------------------------------------------------------------------------
  RTCGET    'GET TIME FROM RTC DEVICE
 '-----------------------------------------------------------------------------
  SetTick 1000,DEJCAS  ' INTERRUPT KAZDOU SEC
 '-----------------------------------------------------------------------------
  RTCGET    'GET TIME FROM RTC DEVICE
 '-----------------------------------------------------------------------------
 '-----------------------------------------------------------------------------
  CAS =1            ' FIRST READING
 '**************** MAIN *******************************************************

 If LCD_MODE$ = "SPI4" Then LCD_MODE=3

SPI4_INIT_LCD

LCD_LINE_3 3		' DEMO TEXT LINE 3
LOC$= "West Vancouver"
      _flag=&H01
        For I=1 To Len(LOC$)
                LCD_Writebyte Asc(Mid$(LOC$,I,1)),1,1
       Next I

LCD_LINE_4 2		'DEMO TEXT LINE 4
LOC$= "British Columbia"
      _flag=&H01
        For I=1 To Len(LOC$)
                LCD_Writebyte Asc(Mid$(LOC$,I,1)),1,1
       Next I

LCD_LINE_1 4
'==================================== Main ==================================
Do
If CAS > 0 Then WRITE_TIME :CAS=0:EndIf
Loop
End
'============================================================================
Sub WRITE_TIME
      LCD_LINE_1 4
      If Date$ <> DATE_OLD$ Then RTCGET: DATE_OLD$=Date$:EndIf
      _flag=&H01
        For I=1 To Len(Time$)
                LCD_Writebyte Asc(Mid$(Time$,I,1)),1,1
       Next I

      LCD_LINE_2
      _flag=&H01
        For I=1 To Len(DOW$)
          LCD_Writebyte Asc(Mid$(DOW$,I,1)),1,1
        Next I

    LCD_LINE_2 10
    _flag=&H01
      For I=1 To Len(Date$)
        LCD_Writebyte Asc(Mid$(Date$,I,1)),1,1
      Next I
End Sub

 '=============================================================================
 Sub LCD_WRITEBYTE (_BYTE,_FLAG,_WAIT_MS)
If LCD_MODE=3 Then
  LCD_NIBBLE_WRITE _BYTE And &HF0,_FLAG,_WAIT_MS
  LCD_NIBBLE_WRITE _BYTE*16 And &HF0,_FLAG,_WAIT_MS
EndIf

If LCD_MODE=4 Then
  LCD_NIBBLE_WRITE _BYTE,_FLAG,_WAIT_MS
EndIf
  End Sub
 '=============================================================================
 Sub LCD_NIBBLE_WRITE (DATA,_FLAG,WAIT_MSEC)
If LCD_MODE = 3 Then  data=data Or _flag
        D= SPI(SPIREAD,SDATA,SCLK,DATA):Pulse LWRITE,0.001
End Sub
'=============================================================================

Sub SPI4_INIT_LCD
       Pause 50
        D= SPI(SPIREAD,SDATA,SCLK,&H30):Pulse LWRITE,0.001: Pause 5
        D= SPI(SPIREAD,SDATA,SCLK,&H30):Pulse LWRITE,0.001: Pause 1
        D= SPI(SPIREAD,SDATA,SCLK,&H30):Pulse LWRITE,0.001: Pause 1
        D= SPI(SPIREAD,SDATA,SCLK,&H20):Pulse LWRITE,0.001: Pause 5
'--------------------------------------------------------------------
        D= SPI(SPIREAD,SDATA,SCLK,&H20):Pulse LWRITE,0.001: Pause 1
        D= SPI(SPIREAD,SDATA,SCLK,&H80):Pulse LWRITE,0.001: Pause 5
        D= SPI(SPIREAD,SDATA,SCLK,&H00):Pulse LWRITE,0.001: Pause 1
        D= SPI(SPIREAD,SDATA,SCLK,&HC0):Pulse LWRITE,0.001: Pause 1
        D= SPI(SPIREAD,SDATA,SCLK,&H00):Pulse LWRITE,0.001: Pause 1
        D= SPI(SPIREAD,SDATA,SCLK,&H10):Pulse LWRITE,0.001: Pause 5
End Sub
'--------------------------------------------------------------------
Sub LCD_CLEAR_DISPLAY
If LCD_MODE=3 Then
        D= SPI(SPIREAD,SDATA,SCLK,&H00):Pulse LWRITE,0.001
        D= SPI(SPIREAD,SDATA,SCLK,&H10):Pulse LWRITE,0.001:Pause 5
End Sub
'--------------------------------------------------------------------

Sub LCD_LINE_1 OFFSET
Local _BYTE
If LCD_MODE=3 Then
  _BYTE= &H80 + OFFSET
  _FLAG=0
  LCD_NIBBLE_WRITE _BYTE And &HF0,_FLAG,_WAIT_MS
  LCD_NIBBLE_WRITE _BYTE*16 And &HF0,_FLAG,_WAIT_MS
EndIf

End Sub
'--------------------------------------------------------------------
Sub LCD_LINE_2 OFFSET
Local _BYTE
If LCD_MODE=3 Then
  _BYTE= &HC0 + OFFSET
  _FLAG=0
  LCD_NIBBLE_WRITE _BYTE And &HF0,_FLAG,_WAIT_MS
  LCD_NIBBLE_WRITE _BYTE*16 And &HF0,_FLAG,_WAIT_MS
EndIf
End Sub
'--------------------------------------------------------------------
Sub LCD_LINE_3 OFFSET
Local _BYTE
If LCD_MODE=3 Then
  _BYTE= &H94 + OFFSET
  _FLAG=0
  LCD_NIBBLE_WRITE _BYTE And &HF0,_FLAG,_WAIT_MS
  LCD_NIBBLE_WRITE _BYTE*16 And &HF0,_FLAG,_WAIT_MS
EndIf

End Sub
'--------------------------------------------------------------------
Sub LCD_LINE_4 OFFSET
Local _BYTE
If LCD_MODE=3 Then
  _BYTE= &HD4 + OFFSET
  _FLAG=0
  LCD_NIBBLE_WRITE _BYTE And &HF0,_FLAG,_WAIT_MS
  LCD_NIBBLE_WRITE _BYTE*16 And &HF0,_FLAG,_WAIT_MS
EndIf

End Sub

'******************************************************************************
'=============*OBSLUHA INTERRUPTU*=============================================
DEJCAS:
        CAS=1
IReturn
'==============================================================================
Sub RTCGET
'------------------------------------------------------------------------------
 Rem I2C RTC BASED ON DS1307
 I2CADDR=&H68 'DS1307
 I2CEN 100,100
 I2CRCV I2CADDR, 0,64, RTCBUFF(0), 1,0
 I2CDIS
 If MM.I2C=1 Then Print "Error!!!NAK was received!":ERR=1:NAK :EndIf
 If MM.I2C=2 Then Print "Error!!!Timeout!":ERR=1:NAK: EndIf
 'If RTCBUFF(63)<>&HAA Then Print "RTC MAY BE CORRUPTED.":ERR=2:CORRUPT:EndIf
 If ERR <> 0 Then Return
 BCDTEMP=RTCBUFF(0)
     GoSub DECIMAL
       SEC$=Str$(DECIMAL)
 BCDTEMP=RTCBUFF(1)
     GoSub DECIMAL
       MIN$=Str$(DECIMAL)
 BCDTEMP=RTCBUFF(2)
     GoSub DECIMAL
       HOURS$=Str$(DECIMAL)
 BCDTEMP=RTCBUFF(4)
     GoSub DECIMAL
       DAY$=Str$(DECIMAL)
 BCDTEMP=RTCBUFF(5)
    GoSub DECIMAL
       MONTH$=Str$(DECIMAL)
 BCDTEMP=RTCBUFF(6)
    GoSub DECIMAL
       YEAR$=Str$(DECIMAL+2000)
 WDAY=RTCBUFF(3)
 On RTCBUFF(3) GoSub NEDELE,PONDELI,UTERY,STREDA,CTVRTEK,PATEK,SOBOTA
    T$=HOURS$+":"+MIN$+":"+SEC$
    D$=DAY$+"-"+MONTH$+"-"+YEAR$
 Time$=T$
 Date$=D$
 'Print "Time has been set to ";Time$;" ";DOW$;Date$
 SYNC=1
 If WDAY < 7 And WDAY >1 Then Sound 888,500 Else Sound 444,100
End Sub
 "-----------------------------------------------------------------------------"
DECIMAL: 'CONVERT TO DECIMAL
   DECIMAL=Fix(BCDTEMP/16)*10
   DECIMAL=DECIMAL+(BCDTEMP And &HF)
Return
'------------------------------------------------------------------------------
NEDELE:
 DOW$="Sunday "
 Return
'------------------------------------------------------------------------------
PONDELI:
 DOW$="Monday "
 Return
'------------------------------------------------------------------------------
UTERY:
 DOW$="Tuesday "
 Return
'------------------------------------------------------------------------------
STREDA:
 DOW$="Wednesday "
 Return
'------------------------------------------------------------------------------
CTVRTEK:
 DOW$="Thursday "
 Return
'------------------------------------------------------------------------------
PATEK:
 DOW$="Friday "
 Return
'------------------------------------------------------------------------------
SOBOTA:
 DOW$="Saturday "
 Return
'------------------------------------------------------------------------------
                                               